VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3630
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6345
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3630
   ScaleWidth      =   6345
   Begin RichTextLib.RichTextBox rchMainText 
      Height          =   3255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4335
      _ExtentX        =   7646
      _ExtentY        =   5741
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"Form1.frx":0000
   End
   Begin VB.Label lblCurrentWord 
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3360
      Width           =   4335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const EM_CHARFROMPOS& = &HD7
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private m_Words As Collection
Private m_Tips As Collection
' Return True if this is a word-separating character.
' Count all non-visible characters as separators.
Private Function IsWordSeparator(ByVal ch As String) As Boolean
    IsWordSeparator = (ch <= " " Or ch > "~")
End Function
' Return the word the mouse is over.
Public Function RichWordOver(rch As RichTextBox, X As Single, Y As Single) As String
Dim pt As POINTAPI
Dim pos As Integer
Dim start_pos As Integer
Dim end_pos As Integer
Dim ch As String
Dim txt As String
Dim txtlen As Integer

    ' Convert the position to pixels.
    pt.X = X \ Screen.TwipsPerPixelX
    pt.Y = Y \ Screen.TwipsPerPixelY

    ' Get the character number
    pos = SendMessage(rch.hWnd, EM_CHARFROMPOS, 0&, pt)
    If pos <= 0 Then Exit Function

    ' Find the start of the word.
    txt = rch.Text
    For start_pos = pos To 1 Step -1
        ' See if this is a word separator.
        ch = Mid$(rch.Text, start_pos, 1)
        If IsWordSeparator(ch) Then Exit For
    Next start_pos
    start_pos = start_pos + 1

    ' Find the end of the word.
    txtlen = Len(txt)
    For end_pos = pos To txtlen
        ' See if this is a word separator.
        ch = Mid$(txt, end_pos, 1)
        If IsWordSeparator(ch) Then Exit For
    Next end_pos
    end_pos = end_pos - 1

    If start_pos <= end_pos Then _
        RichWordOver = Mid$(txt, start_pos, end_pos - start_pos + 1)
End Function

Private Sub Form_Load()
Dim lines(1 To 4) As String

    lines(1) = "Ready-To-Run Visual Basic Algorithms, Second Edition"
    lines(2) = vbCrLf & vbCrLf & _
        "Extend your applications with powerful algorithms written in Visual Basic. Sorting, searching, trees, hashing, advanced recursion, network algorithms, object-oriented programming, and much more. Visual Basic Algorithms updated and expanded for Visual Basic 5." & _
        vbCrLf & vbCrLf & "    "
    lines(3) = "http://www.vb-helper.com/vba.htm"
    lines(4) = vbCrLf & vbCrLf & _
        "(http://www.vb-helper.com/howto_richtextbox_lookup_word_under_mouse.html)"
    rchMainText.Text = lines(1) & lines(2) & lines(3) & lines(4)

    rchMainText.SelStart = 0
    rchMainText.SelLength = Len(lines(1))
    rchMainText.SelFontSize = rchMainText.SelFontSize + 2
    rchMainText.SelFontName = "Times New Roman"
    rchMainText.SelBold = True

    rchMainText.SelStart = Len(lines(1)) + Len(lines(2))
    rchMainText.SelLength = Len(lines(3))
    rchMainText.SelUnderline = True
    rchMainText.SelColor = vbBlue

    rchMainText.SelStart = Len(lines(1)) + Len(lines(2)) + Len(lines(3))
    rchMainText.SelLength = Len(lines(4))
    rchMainText.SelFontSize = rchMainText.SelFontSize - 1
    rchMainText.SelColor = RGB(128, 128, 128)

    rchMainText.SelStart = 0
    rchMainText.SelLength = 0

    ' Make some lookup definitions.
    Set m_Words = New Collection
    Set m_Tips = New Collection
    m_Words.Add "http://www.vb-helper.com/vba.htm"
    m_Tips.Add "Visual Basic Algorithms Web page"

    m_Words.Add "(http://www.vb-helper.com/howto_richtextbox_lookup_word_under_mouse.html)"
    m_Tips.Add "This example's Web page"

    m_Words.Add "more."
    m_Tips.Add "(Including some cool fractal graphics!)"
End Sub

Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - lblCurrentWord.Height
    If hgt < 120 Then hgt = 120
    rchMainText.Move 0, 0, ScaleWidth, hgt
    lblCurrentWord.Move 0, hgt, ScaleWidth
End Sub


Private Sub rchMainText_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim txt As String
Dim tip_txt As String
Dim i As Integer

    ' Get the word under the mouse.
    txt = RichWordOver(rchMainText, X, Y)

    ' Look up the word.
    For i = 1 To m_Words.Count
        If LCase$(txt) = LCase$(m_Words(i)) Then
            tip_txt = m_Tips(i)
            Exit For
        End If
    Next i

    ' Update the label and tooltip.
    If lblCurrentWord.Caption <> tip_txt Then
        lblCurrentWord.Caption = tip_txt
        rchMainText.ToolTipText = tip_txt
    End If
End Sub

